/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin processor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"


//==============================================================================
ScratchGuiPlusEngineAudioProcessor::ScratchGuiPlusEngineAudioProcessor()
	:
	scratch() // default. 'scratch' is prepared in 'prepareToPlay()' 
{
	// initialize the stuff that stays the same during the life-time of this plugin.
	_MM_SET_DENORMALS_ZERO_MODE(_MM_DENORMALS_ZERO_ON);

	windowHeight = 650;
	windowWidth = 200;

	addParameter( scratchPosParam = new AudioParameterFloat("scratchPos", "Scratch Position.", 0.0f, 1.0f, 1.f) );
	addParameter( modeParam = new AudioParameterBool("scratchMode", "Scratch Mode.", false ) );
}

ScratchGuiPlusEngineAudioProcessor::~ScratchGuiPlusEngineAudioProcessor()
{
	
}

//==============================================================================
const String ScratchGuiPlusEngineAudioProcessor::getName() const
{
    return JucePlugin_Name;
}

bool ScratchGuiPlusEngineAudioProcessor::acceptsMidi() const
{
   #if JucePlugin_WantsMidiInput
    return true;
   #else
    return false;
   #endif
}

bool ScratchGuiPlusEngineAudioProcessor::producesMidi() const
{
   #if JucePlugin_ProducesMidiOutput
    return true;
   #else
    return false;
   #endif
}

double ScratchGuiPlusEngineAudioProcessor::getTailLengthSeconds() const
{
    return 0.0;
}

int ScratchGuiPlusEngineAudioProcessor::getNumPrograms()
{
    return 1;   // NB: some hosts don't cope very well if you tell them there are 0 programs,
                // so this should be at least 1, even if you're not really implementing programs.
}

int ScratchGuiPlusEngineAudioProcessor::getCurrentProgram()
{
    return 0;
}

void ScratchGuiPlusEngineAudioProcessor::setCurrentProgram (int index)
{
}

const String ScratchGuiPlusEngineAudioProcessor::getProgramName (int index)
{
    return String();
}

void ScratchGuiPlusEngineAudioProcessor::changeProgramName (int index, const String& newName)
{
}

//==============================================================================
void ScratchGuiPlusEngineAudioProcessor::prepareToPlay (double sampleRate, int samplesPerBlock)
{
	// Use this method as the place to do any pre-playback
	// initialisation that you need..
	scratch.prepareToPlay( (int)sampleRate, (unsigned int)sampleRate, 5.f, windowHeight, 250.f );
}

void ScratchGuiPlusEngineAudioProcessor::releaseResources()
{
	scratch.releaseResources();
	// When playback stops, you can use this as an opportunity to free up any
    // spare memory, etc.
}

#ifndef JucePlugin_PreferredChannelConfigurations
bool ScratchGuiPlusEngineAudioProcessor::setPreferredBusArrangement (bool isInput, int bus, const AudioChannelSet& preferredSet)
{
    // Reject any bus arrangements that are not compatible with your plugin

    const int numChannels = preferredSet.size();

   #if JucePlugin_IsMidiEffect
    if (numChannels != 0)
        return false;
   #elif JucePlugin_IsSynth
    if (isInput || (numChannels != 1 && numChannels != 2))
        return false;
   #else
    if (numChannels != 1 && numChannels != 2)
        return false;

    if (! AudioProcessor::setPreferredBusArrangement (! isInput, bus, preferredSet))
        return false;
   #endif

    return AudioProcessor::setPreferredBusArrangement (isInput, bus, preferredSet);
}
#endif

void ScratchGuiPlusEngineAudioProcessor::processBlock (AudioSampleBuffer& buffer, MidiBuffer& midiMessages)
{
    // const int totalNumInputChannels  = getTotalNumInputChannels();
    // const int totalNumOutputChannels = getTotalNumOutputChannels();

	/*
    // In case we have more outputs than inputs, this code clears any output
    // channels that didn't contain input data, (because these aren't
    // guaranteed to be empty - they may contain garbage).
    // This is here to avoid people getting screaming feedback
    // when they first compile a plugin, but obviously you don't need to keep
    // this code if your algorithm always overwrites all the output channels.
    for (int i = totalNumInputChannels; i < totalNumOutputChannels; ++i)
        buffer.clear (i, 0, buffer.getNumSamples());
	*/

    // This is the place where you'd normally do the guts of your plugin's
    // audio processing...
	float * myStereoBuf[2];
	myStereoBuf[0] = buffer.getWritePointer(0);
	myStereoBuf[1] = buffer.getWritePointer(1);

	float scratchPos = *scratchPosParam;
	bool mouseDown = *modeParam;

	//mouseDown controls the mode: Scratch-mode (mouseDown). Or fill-mode (mouse up).
	scratch.process( myStereoBuf, buffer.getNumSamples(), scratchPos, mouseDown );
}

//==============================================================================
bool ScratchGuiPlusEngineAudioProcessor::hasEditor() const
{
    return true; // (change this to false if you choose to not supply an editor)
}

AudioProcessorEditor* ScratchGuiPlusEngineAudioProcessor::createEditor()
{
    return new ScratchGuiPlusEngineAudioProcessorEditor (*this);
}

//==============================================================================
void ScratchGuiPlusEngineAudioProcessor::getStateInformation (MemoryBlock& destData)
{
    // You should use this method to store your parameters in the memory block.
    // You could do that either as raw data, or use the XML or ValueTree classes
    // as intermediaries to make it easy to save and load complex data.
}

void ScratchGuiPlusEngineAudioProcessor::setStateInformation (const void* data, int sizeInBytes)
{
    // You should use this method to restore your parameters from this memory block,
    // whose contents will have been created by the getStateInformation() call.
}

//==============================================================================
// This creates new instances of the plugin..
AudioProcessor* JUCE_CALLTYPE createPluginFilter()
{
    return new ScratchGuiPlusEngineAudioProcessor();
}
