/*
  ==============================================================================

    ScratchComponent.h
    Created: 7 Jul 2016 12:23:21pm
    Author:  illdoc

  ==============================================================================
*/

#ifndef WAVEFORMCOMPONENT_H_INCLUDED
#define WAVEFORMCOMPONENT_H_INCLUDED

#include "../JuceLibraryCode/JuceHeader.h"

#include "CRingbufGUI.h"


//==============================================================================
/*
*/
class WaveFormComponent	: public Component
{
public:
	WaveFormComponent() = delete;
	WaveFormComponent( WaveFormComponent & ) = delete;

	WaveFormComponent( CRingbufGUI & ringbuf );
    ~WaveFormComponent();
    
    // Draws the waveForm
    void paint (Graphics&) override;
    
    void resized() override;

	// Update waveform in GUI, while recording. Timer is started and stopped by ScratchComponent. ( the parent component )
	// void timerCallback();

	CRingbufGUI & getRingbufGUI() { return ringbuf; }
	
private:
	//int width, height, halfWidth;
    // Averaged audio samples are written to this ringbuffer from 'CWaveformData4GUI'. Values should be 0.0, 1.0 or something inbetween.
	CRingbufGUI & ringbuf;
	
	JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (WaveFormComponent)
};


#endif  // SCRATCHCOMPONENT_H_INCLUDED
